# AutoRest Documentation

1. Installing AutoRest. 
    - You can [install AutoRest](./installing-autorest.md) on Windows, Mac, or Linux.

1. [Defining Clients With OpenAPI](developer/guide/how-autorest-generates-code-from-swagger.md)
    - AutoRest-specific [OpenAPI Extensions](extensions/readme.md)

2. Generating Clients
    - [Command Line Interface](user/command-line-interface.md) - using AutoRest from the command line.
    - using AutoRest in Visual Studio.

3. Using a Generated Client (C#) - overview of the generated code and extensibility points.
    - [Project Setup](client/proj-setup.md)
    - [Initialization](client/init.md)
    - [Operations](client/ops.md)
    - [Authentication](client/auth.md)
    - [Error Handling](client/error.md)
    - [Tracing](client/tracing.md)
    - [Automatic Retries](client/retry.md)

4. AutoRest Architecture
    - Overview
    - Code Generators
    - Modelers

5. [Building AutoRest](developer/guide/building-code.md)

6. [Writing Tests](developer/guide/writing-tests.md)

6. [Writing OpenAPI Validation Rules](https://github.com/Azure/azure-openapi-validator/blob/master/docs/developer/authoring-new-validation-rules.md)

7. Contributing to the code

8. OpenAPI (formerly 'Swagger') specifications:
-  [OpenAPI Spec 2.0](https://github.com/OAI/OpenAPI-Specification/blob/master/versions/2.0.md) (f.k.a. Swagger 2.0)
-  [OpenAPI Spec 3.0.0](https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.0.md) 
